function bowler_root_load()
--	test_bowler_load()
	local default = {}
	default.origin_x = 250
	default.origin_y = 400
	default.health = 3
	default.gliding_speed = 320
	default.jump_power = -65000
	default.can_jump = false
	default.spin_speed = 3
	
	BOWLER = {}
	BOWLER.data = {}
	BOWLER.physbod = {}
	
	bowlercam = {}
	bowlercam.x = default.origin_x - love.graphics.getWidth() / 2
	bowlercam.y = default.origin_y - love.graphics.getHeight() / 1.7
	
	function change_bowler_default(table)
	
	end
	
	function create_bowler(world)
		BOWLER.data.origin_x = default.origin_x
		BOWLER.data.origin_y = default.origin_y
		BOWLER.data.x = BOWLER.data.origin_x
		BOWLER.data.y = BOWLER.data.origin_y
		BOWLER.data.x_vel = 0
		BOWLER.data.y_vel = 0
		BOWLER.data.health = default.health
		
		BOWLER.data.exists = true
		BOWLER.data.alive = true
		
		BOWLER.data.gliding_speed = default.gliding_speed
		BOWLER.data.jump_power = default.jump_power
		BOWLER.data.can_jump = default.can_jump
		BOWLER.data.spin_speed = default.spin_speed
		
		BOWLER.physbod.cb = love.physics.newBody(world, BOWLER.data.x, BOWLER.data.y, "dynamic")
		BOWLER.physbod.cs = love.physics.newCircleShape(20)
		BOWLER.physbod.cf = love.physics.newFixture(BOWLER.physbod.cb, BOWLER.physbod.cs)
	
		BOWLER.physbod.rb = love.physics.newBody(world, BOWLER.data.x, BOWLER.data.y + 10, "dynamic")
		BOWLER.physbod.rs = love.physics.newRectangleShape(40,16)
		BOWLER.physbod.rf = love.physics.newFixture(BOWLER.physbod.rb, BOWLER.physbod.rs)
		
		BOWLER.physbod.pb = love.physics.newBody(world, BOWLER.data.x - 32, BOWLER.data.y - 40, "dynamic")
		BOWLER.physbod.ps = love.physics.newPolygonShape(10,50, 54,50, 64,56, 40,64, 24,64, 0,56)
		BOWLER.physbod.pf = love.physics.newFixture(BOWLER.physbod.pb, BOWLER.physbod.ps)
		
		BOWLER.physbod.j1 = love.physics.newWeldJoint(BOWLER.physbod.cb, BOWLER.physbod.rb, BOWLER.data.x, BOWLER.data.y + 10, false)
		BOWLER.physbod.j2 = love.physics.newWeldJoint(BOWLER.physbod.cb, BOWLER.physbod.pb, BOWLER.data.x - 30, BOWLER.data.y - 40, false)
		
	--	BOWLER.physbod.cb:setMass(0.8)
	--	BOWLER.physbod.rb:setMass(0.8)
	--	BOWLER.physbod.pb:setMass(0.5)
		
		BOWLER.physbod.cb:setAngularDamping(10)
		BOWLER.physbod.rb:setAngularDamping(10)
		BOWLER.physbod.pb:setAngularDamping(10)
		
		BOWLER.physbod.cf:setUserData("player-character-hit")
		BOWLER.physbod.pf:setUserData("player-character")
		
		BOWLER.physbod.cb:setSleepingAllowed(false)
		BOWLER.physbod.rb:setSleepingAllowed(false)
		BOWLER.physbod.pb:setSleepingAllowed(false)
		
	end
	
	create_bowler(test_world)
	
	if testinggfuytf then
		function test_bowler_load()
			tb = {}
			
			tb.circle = {}
			tb.circle.body = love.physics.newBody(test_world, 350, 20, "dynamic")
			tb.circle.shape = love.physics.newCircleShape(20)
			tb.circle.fixture = love.physics.newFixture(tb.circle.body, tb.circle.shape)
			
			tb.rectangle_shaft = {}
			tb.rectangle_shaft.body = love.physics.newBody(test_world, 350, 30, "dynamic")
			tb.rectangle_shaft.shape = love.physics.newRectangleShape(40,16)
			tb.rectangle_shaft.fixture = love.physics.newFixture(tb.rectangle_shaft.body, tb.rectangle_shaft.shape)
			
			tb.joint_1 = love.physics.newWeldJoint(tb.circle.body, tb.rectangle_shaft.body, 350, 30, false)
			
			tb.poly = {}
			tb.poly.body = love.physics.newBody(test_world, 318, -20, "dynamic")
			tb.poly.shape = love.physics.newPolygonShape(10,50, 54,50, 64,56, 40,64, 24,64, 0,56)
			tb.poly.fixture = love.physics.newFixture(tb.poly.body, tb.poly.shape)
			
			tb.joint_2 = love.physics.newWeldJoint(tb.circle.body, tb.poly.body, 320, -20, false)
		end
	end
end



function bowler_update(step)
	BOWLER.data.x = BOWLER.physbod.rb:getX()
	BOWLER.data.y = BOWLER.physbod.rb:getY()

	bowlercam.x = (BOWLER.data.x - love.graphics.getWidth() / 2) * -1
	bowlercam.y = (BOWLER.data.y - love.graphics.getHeight() / 1.7) * -1

	BOWLER.data.x_vel, BOWLER.data.y_vel = BOWLER.physbod.rb:getLinearVelocity()
	BOWLER.data.rotation = math.rad(BOWLER.physbod.rb:getAngle())
	
	if BOWLER.data.y_vel > -1 then
		BOWLER.data.jumping = false
	end
	
	if BOWLER.data.jumping then
		BOWLER.data.can_jump = false
	end
	
	if BOWLER.data.exists and BOWLER.data.alive then
		if love.keyboard.isDown("left") and not love.keyboard.isDown("right") then
			BOWLER.physbod.rb:applyForce(-BOWLER.data.gliding_speed,0)
		elseif love.keyboard.isDown("right") and not love.keyboard.isDown("left") then
			BOWLER.physbod.rb:applyForce(BOWLER.data.gliding_speed,0)
		end
		
		if love.keyboard.isDown("up") and BOWLER.data.can_jump then
			BOWLER.data.can_jump = false
			BOWLER.data.jumping = true
			BOWLER.physbod.rb:applyForce(0,BOWLER.data.jump_power)
		end
		
		if BOWLER.data.jumping and not love.keyboard.isDown("up") then
			BOWLER.data.jumping = false
			BOWLER.physbod.rb:setLinearVelocity(BOWLER.data.x_vel, BOWLER.data.y_vel * 0.8)
		end
	end
end

function bowler_draw()	
--[[	hb.SetColour(200,255,200)
	
	love.graphics.circle("fill", tb.circle.body:getX(), tb.circle.body:getY(), tb.circle.shape:getRadius())
	love.graphics.polygon("fill", tb.rectangle_shaft.body:getWorldPoints(tb.rectangle_shaft.shape:getPoints()))
	love.graphics.polygon("fill", tb.poly.body:getWorldPoints(tb.poly.shape:getPoints()))
	
	hb.SetColour(255,255,255)
	love.graphics.draw(img.bowler_hat, tb.rectangle_shaft.body:getX(), tb.rectangle_shaft.body:getY(), tb.rectangle_shaft.body:getAngle(), 1, 1, 32, 50)
	hb.SetColour(100,100,100)
	love.graphics.draw(img.bowler_band, tb.rectangle_shaft.body:getX(), tb.rectangle_shaft.body:getY(), tb.rectangle_shaft.body:getAngle(), 1, 1, 32, 50)
	--]]
--	hb.SetColour(200,255,200)
	
	love.graphics.circle("fill", BOWLER.physbod.cb:getX(), BOWLER.physbod.cb:getY(), BOWLER.physbod.cs:getRadius())
	love.graphics.polygon("fill", BOWLER.physbod.rb:getWorldPoints(BOWLER.physbod.rs:getPoints()))
	love.graphics.polygon("fill", BOWLER.physbod.pb:getWorldPoints(BOWLER.physbod.ps:getPoints()))
	
--	hb.SetColour(255,255,255)
--	love.graphics.draw(img.bowler_hat, BOWLER.physbod.rb:getX(), BOWLER.physbod.rb:getY(), BOWLER.physbod.rb:getAngle(), 1, 1, 32, 50)
--	hb.SetColour(100,100,100)
--	love.graphics.draw(img.bowler_band, BOWLER.physbod.rb:getX(), BOWLER.physbod.rb:getY(), BOWLER.physbod.rb:getAngle(), 1, 1, 32, 50)
end