gamestate = "main"

require "graphical_stuff"
require "sound_system"

require "mapping_system"
require "stepping_master"

require "characters"
require "entities/bowler"
require "entities/pent"
require "entities/entities_root"

require "scenes/first_menus"
require "scenes/main_level_1"

function love.load()

	hindbodes_modules = true

	pixel_art_style = true
	
	love.graphics.setBackgroundColor(1,1,1)
	
	loaded_game_root = true
	
	if loaded_game_root then
		print("Got through primary LOAD")
	end
end

function love.update(dt)
	if gamestate == "main" then
		if loaded_game_root then			
			if one == nil then
				one = true
			end
			if one then
				--Start loading preloader stuff
				one = false
				print("started ONE")
				
				preloader = {}
				preloader.percent = 0
				
				preloader.finished = false
				preloader.moving = true
				preloader.ready = true
				
				print("ended ONE")
			end
			
			if two == nil and one == false then
				two = true
			end
			if two then
				two = false
				--Start loading other stuff
				print("started TWO")
				preloader.moving = false
				
				if hindbodes_modules == true then
				
					hb = {}
					
					hb.printoff1 = "Hindbodes Modules turned on."
					print(hb.printoff1)
					
					function hb.scaling(type)
						love.graphics.setDefaultFilter("nearest", "nearest")
						if type ~= "nearest" and type ~= "pixel-art" and type ~= "pixelart" then
							love.graphics.setDefaultFilter("linear")
						else
							print("Graphics type is Nearest-Neighbour scaling.")
						end
					end
					
					function hb.SetColour(r, g, b, o)
						if o == nil then
							if r ~= nil and g ~= nil and b ~= nil then
								love.graphics.setColor(r / 255, g / 255, b / 255)
							else
								love.graphics.setColor(r[1] / 255, r[2] / 255, r[3] / 255)
							end
						else
							if r ~= nil and g ~= nil and b ~= nil and o ~= nil then
								love.graphics.setColor(r / 255, g / 255, b / 255, o / 100)
							else
								love.graphics.setColor(r[1] / 255, r[2] / 255, r[3] / 255, r[4] / 100)
							end
						end
					end
					
					function hb.SetBackgroundColour(rb, gb, bb)
						if rb ~= nil and gb ~= nil and bb ~= nil then
							love.graphics.setBackgroundColor(rb / 255, gb / 255, bb / 255)
						else
							love.graphics.setBackgroundColor(rb[1] / 255, rb[2] / 255, rb[3] / 255)
						end
					end
					
					hb.colours = {}
					
					hb.colours.fraggus_grey = {26, 26, 26}
					hb.colours.doomsday_redraw = {139, 58, 84}
					hb.colours.weta_sky = {0, 0, 204}
					hb.colours.weta_sky2 = {1, 1, 126}
					hb.colours.weta_sky3 = {0, 0, 102}
					hb.colours.weta_sky4 = {0, 0, 60}
					hb.colours.weta_sky5 = {0, 0, 17}
					hb.colours.legacy_red = {255, 0, 0}
					hb.colours.total_white = {255, 255, 255}
					hb.colours.nice_green = {24, 63, 28}
					hb.colours.megadark_green = {1, 20, 1}
					hb.colours.ruby_septagon_red = {173, 24, 19}
					hb.colours.total_black = {0, 0, 0}
					hb.colours.ed_wood = {173,120,58}
					hb.colours.doozle = {26,158,100}
					
					import = {}
					import.arial = love.graphics.newFont("font/arial.ttf")
					import.arial_bold = love.graphics.newFont("font/arialbd.ttf")
					import.cambria = love.graphics.newFont("font/cambria.ttc")
					import.cooper_black = love.graphics.newFont("font/CooperBlackStd.otf")
					import.narkism = love.graphics.newFont("font/Narkism.ttf")
					
					love.graphics.setFont(import.arial)
					
					hb.fonts = {}
					hb.fonts.pixelbro = love.graphics.newImageFont("font/Pixelbro.png", "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz 1234567890,.!?'_-();:", 0.5)
					
					function hb.text(text, x, y, font)
						love.graphics.setFont(font)
						love.graphics.print(text, x, y)
					end
					
					function hb.simple_text(text, xpos, ypos)
						love.graphics.setFont(import.arial)
						love.graphics.print(text, xpos, ypos)
					end
					
					function hb.medium_text(text, x, y, font, rescale_type, offset_x, offset_y)
					--	The idea here is that the font used increases in size.
						love.graphics.setFont(font)
						if rescale_type == "nearest" then
							font:setFilter("nearest", "nearest")
						else
							font:setFilter("linear", "linear")
						end
						
						love.graphics.print(text, x, y, 0, 2, 2, offset_x, offset_y)
					end
					
					function hb.big_text(text, x, y, font, rescale_type)
						love.graphics.setFont(font)
						if rescale_type == "nearest" then
							font:setFilter("nearest", "nearest")
						else
							font:setFilter("linear", "linear")
						end
						
						love.graphics.print(text, x, y, 0, 3, 3)
					end
					
					function hb.huge_text(text, x, y, font, rescale_type)
						love.graphics.setFont(font)
						if rescale_type == "nearest" then
							font:setFilter("nearest", "nearest")
						else
							font:setFilter("linear", "linear")
						end
						
						love.graphics.print(text, x, y, 0, 4, 4)
					end
					
					function hb.campush()
						love.graphics.push()
					end
					
					function hb.campop()
						love.graphics.pop()
					end
					
					if pixel_art_style == true then
					--	hb.scaling("pixel-art")
						love.graphics.setDefaultFilter("nearest","nearest")
					else
					--	hb.scaling("linear")
						love.graphics.setDefaultFilter("linear","linear")
					end
				end
				
				preloader.moving = true
				print("ended TWO")
			end
			
			if three then
				three = false
				--Start loading more stuff
				print("started THREE")
				preloader.moving = false
				
				
				
				test_world = love.physics.newWorld(0,200,true)
				
				
				graphics_load()
				map_system_load()
				menus_load()
				characters_load()
				entities_root_load()
				audio_load()
				main_level_1_load()
				
				function contact_begin_CC(a, b, cozl)
					local a_ball = a:getUserData()
					local b_ball = b:getUserData()
					
					if a_ball == "player-character" or a_ball == "player-character-hit" and b_ball == "floor" and BOWLER.data.y_vel == 0 then
						--print("Can jump again")
						BOWLER.data.can_jump = true
						BOWLER.data.jumping = false
					elseif b_ball == "player-character" or b_ball == "player-character-hit" and a_ball == "floor" and BOWLER.data.y_vel == 0 then
						--print("Can jump again")
						BOWLER.data.can_jump = true
						BOWLER.data.jumping = false
					end
				end
				
				function conctact_end_CC(a, b, cozl)
				
				end
				
				function presolve_CC(a, b, cozl)
				
				end
				
				function postsolve_CC(a, b, cozl, normalimpulse, tangentimpulse)
				
				end
				test_world:setCallbacks(contact_begin_CC, conctact_end_CC, presolve_CC, postsolve_CC)
			
				preloader.moving = true
				print("ended THREE")
				
				
			end
			
			if preloader.ready then
				if preloader.moving and preloader.percent < 100 then
					preloader.percent = preloader.percent + 2
				elseif preloader.percent >= 100 then
					preloader.finished = true
					preloader.moving = false
					preloader.percent = 100
				end
				
				if preloader.percent >= 50 then
					if three == nil and two == false then
						three = true
					end
				end
			end			
		end
		
		if preloader.finished then
			hb.SetBackgroundColour(hb.colours.total_black)
			gamestate = "start"
		end
		
	elseif gamestate == "start" then
		step_update(main_level_1_update, dt)
	end
end

function love.draw()
	if gamestate == "main" then
	
	elseif gamestate == "start" then
		main_level_1_draw()
	end
end

function love.focus(bool)

end

function love.keypressed(key, scancode, isrepeat)

end

function love.keyreleased(key, scancode)

end

function love.mousepressed(x, y, button, istouch)
	
end

function love.mousereleased(x, y, button, istouch)

end